from can_id_sheet import CAN_ID, VehicleSegment
from periodic_send_thread import PeriodicSendingTask

from multiprocessing import Process

from scapy.contrib.cansocket import *
from scapy.layers.can import *
from scapy.sendrecv import *

class ChassisECU(Process):
    def __init__(self,
                 # socket, # type: Optional[CANSocket]
                 vehicle_segment: VehicleSegment
                 ):
        Process.__init__(self)
        # self.socket = socket
        self.frames_to_send = [frame for frame in CAN_ID if frame.source == vehicle_segment]
        self.name = vehicle_segment.name
    def run(self):
        print('hello from ECU with segment: ' + str(self.name) + ' and socket: ')
        # + str(self.socket.fd))

        t1 = PeriodicSendingTask(
            # socket=self.socket,
            frames=self.frames_to_send,
            interval_s=5)
        t2 = PeriodicSendingTask(
            # socket=self.socket,
            frames=[frame for frame in CAN_ID if frame.interval == 0.5],
            interval_s=1)

        t1.start()
        t2.start()

        time.sleep(20)

        t1.join(timeout=5)
        t2.join(timeout=5)
