from can_id_sheet import CAN_ID

from threading import Thread
from scapy.contrib.cansocket import *
from scapy.sendrecv import send
import time

NANOSECONDS_IN_SECOND: int = 1_000_000_000


class PeriodicSendingTask(Thread):
    def __init__(self,
                 # socket, # type: CANSocket,
                 frames: list[CAN_ID],
                 interval_s: float):
        super().__init__()
        self.daemon = True
        self.stopped = False    # maybe add a way to gracefully stop
        # self.socket = socket
        self.frames = frames
        self.interval_ns = int(round(interval_s * NANOSECONDS_IN_SECOND))

    def run(self) -> None:
        msg_due_time_ns = time.perf_counter_ns()

        while not self.stopped:
            # to be replaced with sending
            print(str(len(self.frames)) + ' ' + str(time.time()))

            msg_due_time_ns += self.interval_ns
            # Compensate for the time it takes to send the message
            delay_ns = msg_due_time_ns - time.perf_counter_ns()
            if delay_ns > 0:
                time.sleep(delay_ns / NANOSECONDS_IN_SECOND)
